
;;; d-before-save-hook.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-before-save-hook.el
;; Author/Maintainer: Davin Pearson <http://davin.50webs.com>
;; Keywords: before save hook
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:
(add-hook 'before-save-hook 'd-before-save-hook)

(defun d-before-save-hook ()
  "Trims excess spaces at ends of line"
  (when (not (eq major-mode 'hexl-mode))
    (read-only-mode -1)
    (goto-char (point-min))
    (when (and t
               ;;(not (save-excursion (re-search-forward (make-string 1 0) nil t))) ;; ^@
               ;;(not (save-excursion (re-search-forward (make-string 1 1) nil t))) ;; ^a
               ;;(not (save-excursion (re-search-forward (make-string 1 2) nil t))) ;; ^b
               ;;(not (save-excursion (re-search-forward (make-string 1 3) nil t))) ;; ^c
               ;;(not (save-excursion (re-search-forward (make-string 1 4) nil t))) ;; ^d
               ;;(not (save-excursion (re-search-forward (make-string 1 5) nil t))) ;; ^e
               ;;(not (save-excursion (re-search-forward (make-string 1 6) nil t))) ;; ^f
               ;;(not (save-excursion (re-search-forward (make-string 1 7) nil t))) ;; ^g
               ;;(not (save-excursion (re-search-forward (make-string 1 8) nil t))) ;; ^h
               ;; --------------------------------------------------------
               ;;(not (re-search-forward (make-string 1 9) nil t)) ;; ^i
               ;;(not (re-search-forward (make-string 1 10) nil t)) ;; ^j
               ;;(not (save-excursion (re-search-forward (make-string 1 11) nil t))) ;; ^k
               ;;(not (re-search-forward (make-string 1 12) nil t)) ;; ^l
               ;;(not (re-search-forward (make-string 1 13) nil t)) ;; ^m
               ;;-----------------------------------------------------
               ;;(not (save-excursion (re-search-forward (make-string 1 14) nil t))) ;; ^n
               ;;(not (save-excursion (re-search-forward (make-string 1 15) nil t))) ;; ^o
               ;;(not (save-excursion (re-search-forward (make-string 1 16) nil t))) ;; ^p
               ;;(not (save-excursion (re-search-forward (make-string 1 17) nil t))) ;; ^q
               ;;(not (save-excursion (re-search-forward (make-string 1 18) nil t))) ;; ^r
               ;;(not (save-excursion (re-search-forward (make-string 1 19) nil t))) ;; ^s
               ;;(not (save-excursion (re-search-forward (make-string 1 20) nil t))) ;; ^t
               ;;(not (save-excursion (re-search-forward (make-string 1 21) nil t))) ;; ^u
               ;;(not (save-excursion (re-search-forward (make-string 1 22) nil t))) ;; ^v
               ;;(not (save-excursion (re-search-forward (make-string 1 23) nil t))) ;; ^w
               ;;(not (save-excursion (re-search-forward (make-string 1 24) nil t))) ;; ^x
               ;;(not (save-excursion (re-search-forward (make-string 1 25) nil t))) ;; ^y
               ;;(not (save-excursion (re-search-forward (make-string 1 26) nil t))) ;; ^z
               )
      (goto-char (point-min))
      (while (re-search-forward "[^ ]\\([ \t]*$\\)" nil t)
        (delete-region (match-beginning 1) (match-end 1)))
      )))

(provide 'd-before-save-hook)
