
;;; d-eshell.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-eshell.el
;; Author/Maintainer: Davin Pearson <http://davin.50webs.com>
;; Keywords: eshell functionality
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

;;(setq eshell-ask-to-save-history nil)

(setq eshell-save-history-on-exit t)

(progn
  (make-face 'eshell-ls-archive)
  (set-face-foreground 'eshell-ls-archive "#f00")
  (copy-face 'font-lock-keyword-face 'eshell-prompt-face)
  (copy-face 'fg:lightblue           'eshell-ls-directory-face)

  (progn
    (make-face 'dc-face-dired-executable)
    (set-face-foreground 'dc-face-dired-executable "#0c0")
    (copy-face 'dc-face-dired-executable  'eshell-ls-executable))

  (progn
    (make-face 'dc-face-dired-archives)
    (set-face-foreground 'dc-face-dired-archives "#f00")
    (copy-face 'dc-face-dired-archives    'eshell-ls-archives))

  (progn
    (make-face 'dc-face-dired-unimportant)
    (set-face-foreground 'dc-face-dired-unimportant "#888")
    (copy-face 'dc-face-dired-unimportant 'eshell-ls-backup)
    )

  (progn
    (make-face 'dc-face-dired-binaries)
    (set-face-foreground 'dc-face-dired-binaries "#0f0")
    (copy-face 'dc-face-dired-binaries    'eshell-ls-product))

  (progn
    (make-face 'bg:lightmagenta)
    (set-face-background 'bg:lightmagenta "#f0f"))

  (progn
    (make-face 'bg:lightred)
    (set-face-background 'bg:lightred "#f00"))

  (progn
    (make-face 'eshell-ls-archive-face)
    (set-face-foreground 'eshell-ls-archive-face "#f88")
    )

  (progn
    (make-face 'fg:lightmagenta)
    (set-face-foreground 'fg:lightmagenta "#f0f"))

  (make-face-bold 'eshell-ls-archive)

  (progn
    (make-face 'd-face-dired-deleteme)
    (set-face-foreground 'd-face-dired-deleteme "#f0f"))

  (progn
    (make-face 'd-face-dired-movies)
    (set-face-background 'd-face-dired-movies "#f0f"))

  (copy-face 'fg:lightmagenta        'eshell-ls-readonly-face)
  (copy-face 'fg:lightmagenta        'eshell-ls-unreadable-face)
  (copy-face 'fg:darkgray            'eshell-ls-backup-face)

 )

(setq eshell-command-aliases-list '(("ll"   "ls -l")
                                    ("l"    "ls -l")
                                    ("/"    "cd /")
                                    (".."   "cd ..")
                                    ("cd/"  "cd /")
                                    ("cd.." "cd ..")
                                    ("x"    "exit")))

(provide 'd-eshell)
;;; d-eshell.el ends here
