
;;; d-movement-leftright.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-movement-leftright.el
;; Author/Maintainer: Davin Pearson <http://davin.50webs.com>
;; Keywords: left/right movement functionality
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

(global-set-key [left] 'd-movement-left)

(defun d-movement-left ()
  (interactive)
  (if (not (d-movement--is-correct-mode))
      (backward-char)
    (if (> (current-column) 0)
        (backward-char 1)
      (beep))))

(global-set-key [right] 'd-movement-right)

(defun d-movement-right ()
  (interactive)
  (forward-char 1))

(provide 'd-movement-leftright)
