
;;; d-php-mode.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-php-mode.el
;; Author/Maintainer: Davin Pearson <http://davin.50webs.com>
;; Keywords: P.H.P. mode code
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

(load-file (concat (car load-path) "/imported-stuff/php-mode.el"))

(defun d-php-mode-hook ()
  (setq font-lock-keywords-case-fold-search nil)
  (modify-syntax-entry ?' "w")
  (d-font-lock-add-begin
   '(
     ("<[/?]*[a-z][a-zA-Z0-9_ \"=]+>" 0 'bold nil))))

(add-hook 'php-mode-hook 'd-php-mode-hook)

(setq auto-mode-alist
      (append
       '(
         ("\\.php$" . php-mode)
         )
       auto-mode-alist))

(provide 'd-php-mode)
;;; d-php-mode.el ends here
