
;;; d-prolog.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-prolog.el
;; Author/Maintainer: Davin Pearson <http://davin.50webs.com>
;; Keywords: Prolog major mode code
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

(setq auto-mode-alist
      (append '(
                ("\\.pl" . prolog-mode))
              auto-mode-alist))

(add-hook 'find-file-hook 'd-prolog-turn-on-font-lock)
(defun d-prolog-turn-on-font-lock ()
  (if (eq major-mode 'prolog-mode)
      (font-lock-mode 1)))

(add-hook 'font-lock-mode-hook 'd-prolog-fonts)
(defun d-prolog-fonts ()
  ;;(d-foo)
  (when (eq major-mode 'prolog-mode)
    (d-font-lock-add-end '(
                           (":-" 0 'fg:lightgreen t)
                           ("[][(),.!]" 0 'fg:lightgreen nil)
                           ("\\<[A-Z]\\sw*\\>" 0 'fg:yellow nil)))
    )
  )

(provide 'd-prolog)
;;; d-prolog.el ends here
