
;;; d-truncate-hook.el

;; Copyright (C) 2014-2015 Davin Pearson

;; Emacs Lisp Archive Entry
;; Filename: d-truncate-hook.el
;; Author/Maintainer: Davin Pearson <http://davin.50webs.com>
;; Keywords: truncate hook
;; Version: 1.0

;;; Commentary:

;; This file is not part of GNU Emacs.

;;; Limitation of Warranty

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or (at
;; your option) any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs, see the file COPYING.  If not, see:
;;
;; <http://www.gnu.org/licenses/gpl-3.0.txt>.


;;; Known Bugs:

;; None so far!

;;; Code:

;;(add-hook 'find-file-hook 'd-truncate-hook)

(defun d-truncate-hook ()
  (when (string-match "\\.level$" (buffer-file-name))
    (setq truncate-lines t)
    (local-set-key [up  ] 'previous-line)
    (local-set-key [down] 'next-line)
    (picture-mode))
  (when (or (eq major-mode 'c++-mode)
            (eq major-mode 'makefile-mode)
            (eq major-mode 'compilation-mode)
            (eq major-mode 'text-mode))
    (setq truncate-lines t))
  )

(provide 'd-truncate-hook)
;;; d-truncate-hook.el ends here
